<?php

namespace Drupal\smallads_murmurations;

use Drupal\Core\Routing\RouteSubscriberBase;
use Symfony\Component\Routing\RouteCollection;
use Symfony\Component\Routing\Route;

/**
 * Because the transaction collection is also the field ui base route, and
 * because views provides a superior listing to the entity's official
 * list_builder, this alters that view's route to comply with the entity.
 */
class RouteSubscriber extends RouteSubscriberBase {

  /**
   * {@inheritdoc}
   */
  protected function alterRoutes(RouteCollection $collection) {
    if ($collection->get('view.smallads_auto_page.offer')) {
      $collection->add('smallads_murmurations.offer.map',
        new Route(
          '/offers/global',
          [
            '_form' => '\Drupal\murmurations\Form\FilterFormMap',
            '_title' =>  'Search network offers'
          ],
          ['_permission' => 'post smallads'],
          [
            'plugin' => 'offer_want',
            'exchange_type' => 'offer'
          ]
        )
      );
      $collection->add('smallads_murmurations.offer.list',
        new Route(
          '/offers/global/list',
          [
            '_form' => '\Drupal\murmurations\Form\FilterFormList',
            '_title' =>  'Search network offers'
          ],
          ['_permission' => 'post smallads'],
          [
            'plugin' => 'offer_want',
            'exchange_type' => 'offer'
          ]
        )
      );
    }
    if ($collection->get('view.smallads_auto_page.want')) {
      $collection->add('smallads_murmurations.want.map',
        new Route(
          '/wants/global',
          [
            '_form' => '\Drupal\murmurations\Form\FilterFormMap',
            '_title' =>  'Search network wants'
          ],
          [
            '_permission' => 'post smallads'
          ],
          [
            'plugin' => 'offer_want',
            'exchange_type' => 'want'
          ]
        )
      );
      $collection->add('smallads_murmurations.want.list',
        new Route(
          '/wants/global/list',
          [
            '_form' => '\Drupal\murmurations\Form\FilterFormList',
            '_title' =>  'Search network wants'
          ],
          [
            '_permission' => 'post smallads'
          ],
          [
            'plugin' => 'offer_want',
            'exchange_type' => 'want'
          ]
        )
      );
    }
  }

}
